/**************************************************************************
 * clients.h
 *
 * Modified: 2008.076
 **************************************************************************/

#ifndef CLIENTS_H
#define CLIENTS_H 1

#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>
#include <pthread.h>

#include <libdali.h>

/* Connection information for client threads */
typedef struct ClientInfo_s {
  int         socket;       /* Socket descriptor */
  int         socketerr;    /* Socket error flag */
  char        addrstr[50];  /* Remote address in ip:port format */
  DLCP       *dlcp;         /* DataLink connection parameters */
  char       *match;        /* Match pattern */
  char       *reject;       /* Reject pattern */
  int64_t     lastid;       /* Last packet ID sent to client */
} ClientInfo;

extern void *ClientThread (void *arg);

#ifdef __cplusplus
}
#endif

#endif /* CLIENTS_H */
