/**************************************************************************
 * dali2liss.h
 *
 * Modified: 2008.077
 **************************************************************************/

#ifndef DALI2LISS_H
#define DALI2LISS_H 1

#include <pthread.h>
#include "clients.h"

#ifdef __cplusplus
extern "C" {
#endif

#define NIPQUAD(addr)		     \
        ((unsigned char *)&addr)[0], \
        ((unsigned char *)&addr)[1], \
        ((unsigned char *)&addr)[2], \
        ((unsigned char *)&addr)[3]

/* Thread data flags */ 
#define TDF_SPAWNING    (1<<0)          /* Thread is now spawning   */
#define TDF_ACTIVE      (1<<1)          /* If set, thread is active */
#define TDF_CLOSE       (1<<2)          /* If set, thread closes    */
#define TDF_CLOSING     (1<<3)          /* Thread in close process  */
#define TDF_CLOSED      (1<<4)          /* Thread is closed         */

/* Thread data associated with most threads */
struct thread_data {
  pthread_mutex_t td_lock;
  pthread_t       td_id;
  int             td_flags;
  int             td_done;
  void           *td_prvtptr;
};

/* Doubly-linkable structure to list client threads */
struct cthread {
  struct thread_data *td;
  struct cthread *prev;
  struct cthread *next;
};

/* Global variables declared in ringserver.c */
extern pthread_mutex_t cthreads_lock;
extern struct cthread *cthreads;

#ifdef __cplusplus
}
#endif

#endif /* DALI2LISS_H */
